require 'yaml'

module Columbus3
  class Sidecar
    def initialize filename
      @metadata = Hash.new
      @metadata[:filename] = filename
    end

    def metadata= metadata
      filename = @metadata[:filename]
      @metadata = metadata
      @metadata[:filename] = filename
    end

    def metadata
      @metadata
    end

    def keys
      @metadata.keys
    end

    # it always works because initialization requires a filename
    def filename
      @metadata[:filename] + ".yaml"
    end

    def load
      @metadata = YAML.load(File.read(@metadata[:filename] + ".yaml"))
    end

    def save
      File.open(@metadata[:filename] + ".yaml", "w") do |file|
        file << @metadata.to_yaml
      end
    end

    def exists?
      File.exist?(@metadata[:filename] + ".yaml")
    end

    # an alias
    def exist? 
      exists?
    end
  end

  class SidecarSearch
    def initialize
      @metadata = Array.new
    end

    def load array
      @metadata = array.each.map { |x| YAML.load(File.read(x)).merge({ path: x.gsub(/\.yaml$/, ''), yaml: x }) }
    end

    def search term
      @metadata.select { |x| eval(term) }
    end
  end
end
